import 'package:js/js.dart';
import 'package:tencent_im_sdk_plugin_platform_interface/enum/message_elem_type.dart';

@JS("TIM")
class MsgEnum {
  external static dynamic TYPES; // 这个是用作枚举的
}

class MsgType {
  static String MSG_TEXT = MsgEnum.TYPES.MSG_TEXT;
  static String MSG_IMAGE = MsgEnum.TYPES.MSG_IMAGE;
  static String MSG_SOUND = MsgEnum.TYPES.MSG_SOUND;
  static String MSG_AUDIO = MsgEnum.TYPES.MSG_AUDIO;
  static String MSG_VIDEO = MsgEnum.TYPES.MSG_VIDEO;
  static String MSG_FILE = MsgEnum.TYPES.MSG_FILE;
  static String MSG_LOCATION = MsgEnum.TYPES.MSG_LOCATION ?? "MSG_LOCATION";
  static String MSG_CUSTOM = MsgEnum.TYPES.MSG_CUSTOM;
  static String MSG_GRP_TIP = MsgEnum.TYPES.MSG_GRP_TIP;
  static String MSG_GRP_SYS_NOTICE = MsgEnum.TYPES.MSG_GRP_SYS_NOTICE;
  static String MSG_MERGER = MsgEnum.TYPES.MSG_MERGER;
  static String MSG_FACE = MsgEnum.TYPES.MSG_FACE;

  static int convertMsgType(String type) {
    if (type == MSG_TEXT) {
      return MessageElemType.V2TIM_ELEM_TYPE_TEXT;
    }
    if (type == MSG_IMAGE) {
      return MessageElemType.V2TIM_ELEM_TYPE_IMAGE;
    }
    if (type == MSG_AUDIO) {
      return MessageElemType.V2TIM_ELEM_TYPE_SOUND;
    }
    print(type);
    // if (type == MSG_AUDIO) {
    //   return MessageElemType.V2TIM_ELEM_TYPE_TEXT;
    // }
    if (type == MSG_VIDEO) {
      return MessageElemType.V2TIM_ELEM_TYPE_VIDEO;
    }
    if (type == MSG_FILE) {
      return MessageElemType.V2TIM_ELEM_TYPE_FILE;
    }
    if (type == MSG_LOCATION) {
      return MessageElemType.V2TIM_ELEM_TYPE_LOCATION;
    }
    if (type == MSG_CUSTOM) {
      return MessageElemType.V2TIM_ELEM_TYPE_CUSTOM;
    }
    if (type == MSG_GRP_TIP) {
      return MessageElemType.V2TIM_ELEM_TYPE_GROUP_TIPS;
    }
    if (type == MSG_GRP_SYS_NOTICE) {
      return MessageElemType.V2TIM_ELEM_TYPE_TEXT;
    }
    if (type == MSG_MERGER) {
      return MessageElemType.V2TIM_ELEM_TYPE_MERGER;
    }

    if (type == MSG_FACE) {
      return MessageElemType.V2TIM_ELEM_TYPE_FACE;
    }

    return MessageElemType.V2TIM_ELEM_TYPE_NONE;
  }
}
